use strict;

if ($ARGV[0] eq '') {print "EXIT. No example specified";exit;}

my ($book,$bookHTML,$example,$output);

open  IN, "../Books/Sources/book$ARGV[0].xml";
read IN, $book, 5000000;
close IN;

open  IN, "../Books/Book$ARGV[0]/book.html";
read IN, $bookHTML, 5000000;
close IN;

open OUT, ">../Books/Book$ARGV[0]/bookInOne.html";

my ($author, $title);

$bookHTML =~ /<H3.*?>(.*?)<\/H3>/gs;
$author = $1;

$bookHTML =~ /<H3.*?>(.*?)<\/H3>/gs;
$title = $1;
$title =~ s/<SUP>.*?<\/SUP>//s;
$title =~ s/#/xmlSource.html/s;


print OUT "
<HTML><HEAD>
	<META http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">
	<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
	<BASE target='_blank'>
</HEAD><BODY>
<TABLE width='100%' border='0' cellspacing='0'><TR><TH class='titlebar'><SPAN class='titlebar'>&nbsp;&nbsp;$author&nbsp;&nbsp;</SPAN><BR><SPAN class='titlebar'>&nbsp;&nbsp;$title&nbsp;&nbsp;</SPAN></TH><TD class='titlebar'>
<A class='titlebar' href='../../General/keywordsInOne.html'>&nbsp;&nbsp;KEYWORDS&nbsp;&nbsp;</A>&nbsp;&nbsp;
<A class='titlebar' href='../../General/examplesInOne.html'>&nbsp;&nbsp;EXAMPLES&nbsp;&nbsp;</A>&nbsp;&nbsp;
<A class='titlebar' href='../../General/authorsInOne.html'>&nbsp;&nbsp;AUTHORS&nbsp;&nbsp;</A>
&nbsp;&nbsp;
<A class='titlebar' href='http://www.zvon.org/ZvonHTML/Zvon/zvonTutorials_en.html'>&nbsp;&nbsp;ZVON&nbsp;&nbsp;</A>
&nbsp;&nbsp;&nbsp;</TD></TR></TABLE>
";

print OUT "

<TABLE width='100%' border='0' cellspacing='0' class='contents'>
<TR><TD><img src='http://www.navrcholu.cz/cgi-bin/4web/nvhit.pl?id=00009880' width='1' height='1' alt='' border='0'></TD></TR>
";

my $counter;
$counter=1;
while ($book =~ /<chapter\s+(.*?)>/sg)
{
my ($chapter,$name);
$chapter = $1;
$chapter =~ /name\s*=\s*["']\s*(.*?)\s*['"]/s;
$name=$1;

$output = "$output<A name='chapter$counter'></A><H3 class='CHAPTER'>$name</H3>";
print OUT "<TR><TD><A class='CHAPTER' target='_top' href='#chapter$counter'>$name</A></TD></TR>";

$chapter =~ /pages\s*=\s*["']\s*(.*?)\s*['"]/s;
my $ex;
foreach $ex (split(/\s+/,$1))
{

 if (open EXAMPLE, "../Examples/Example$ex/exampleInOne.html")
 {
 	printExample($ex);
	}
close EXAMPLE;
}
$counter++;
}

print OUT "</TABLE>\n";
print OUT $output;
print OUT "</BODY></HTML>";
close OUT;

sub printExample
{
read EXAMPLE, $example, 5000000;

$example=~/<P.*?>(.*?)<\/P/s;
$example= $1;
$example=~s/='#id/='..\/..\/Examples\/Example$_[0]\/exampleInOne.html#id/sg;

$output =  "$output\n<P><A  href='../../Examples/Example$_[0]/exampleInOne.html' class='exNumber'>Example $_[0]</A>: $example</P>";

}
