use strict;

if ($ARGV[0] eq '') {print "EXIT. No example specified";exit;}


chdir "../Examples/Example$ARGV[0]";

my (@dirContents,$xmlID);

opendir DIR, '.';
@dirContents = readdir DIR;
close DIR;

open OUT, ">exampleInOne.html";

my $description;
open DESCRIPTION, "description.html";
read DESCRIPTION, $description, 1000000;
close DESCRIPTION;

$description =~ /(<.*?<\/HEAD>)/s;
print OUT "$1\n<BODY>";

$description=~ /<TABLE>.*?<TH.*?>(.*?)<BR>(.*?)<\/TH>.*?<TD.*?>(.*?)<\/TD>.*?<\/TABLE>/s;

my ($author, $exampleID);

$author=$1;
$exampleID=$2;
$description=$3;
;

$author=~s/href/class='titlebar' href/s;
$author=~s/<\//&nbsp;&nbsp;<\//s;
$author=~s/'>/'>&nbsp;&nbsp;/s;


$exampleID=~s/#/exampleSource\.html/s;
$exampleID=~s/<SUP>.*?<\/SUP>//s;
$exampleID=~s/'TAG'/'titlebar'/s;
$exampleID=~s/<\//&nbsp;&nbsp;<\//s;
$exampleID=~s/'>/'>&nbsp;&nbsp;/s;


$description = "<TABLE width='100%' border='0' cellspacing='0'><TR><TH class='titlebar'>&nbsp;&nbsp;&nbsp;$author $exampleID</TH><TD class='titlebar'><A class='titlebar' href='../../General/keywordsInOne.html'>&nbsp;&nbsp;KEYWORDS&nbsp;&nbsp;</A>&nbsp;&nbsp;<A class='titlebar' href='../../General/examplesInOne.html'>&nbsp;&nbsp;EXAMPLES&nbsp;&nbsp;</A>&nbsp;&nbsp;<A class='titlebar' href='../../General/authorsInOne.html'>&nbsp;&nbsp;AUTHORS&nbsp;&nbsp;</A>&nbsp;&nbsp;&nbsp;</TD></TR></TABLE>
<P><img src='http://www.navrcholu.cz/cgi-bin/4web/nvhit.pl?id=00009880' width='1' height='1' alt='' border='0'>$description</P>
";

$description =~ s/target='XSL'//g;
$description =~ s/(id\d+)_xslSource\.html/#$1/g;
$description =~ s/description\.html/exampleInOne.html/g;
print OUT $description;

my ($x,$idSelection);

open SELECTION, "stylesheetsSelection.html";
read SELECTION, $idSelection, 1000000;
close SELECTION;

$idSelection=~/<BODY.*?>(.*?)<\/BODY/s;
$idSelection = $1;
$idSelection =~ s/target='XSL' class='ST'/class='inOneXML'/g;
$idSelection =~ s/(id\d+)_xslSource.html/#$1/g; 
$idSelection =~ s/>(\d+)</>&nbsp;&nbsp;XSL $1&nbsp;&nbsp;</g;

foreach $x (@dirContents)
{
if ($x =~ /xmlSource/)
	 {
	 		my $xml;
	 	 	open XML, $x;
		  read XML, $xml, 1000000;
			close XML;
			
			$x=~/(id\d+)/;
			$xmlID = $1;
			$xml=~s/<TR>.*?<H3>.*?>(.*?)<.*?<\/H3>.*?<\/TR>//s;
			
			print OUT "<a name='$xmlID'>";

						print OUT "<BR><TABLE width='100%' border='0' cellspacing='0'>

			<TR><TH class='inOneXML'>&nbsp;&nbsp;&nbsp;<SPAN class='inOneXML'>&nbsp;&nbsp;XML&nbsp;&nbsp;</SPAN></TH>
			<TD class='inOneXML'><A class='inOneXML' href='#'>&nbsp;&nbsp;HOME&nbsp;&nbsp;</A> $idSelection&nbsp;&nbsp;&nbsp;</TD>
			</TR></TABLE>";
			$xml =~ /(<TABLE>.*<\/TABLE>)/s;
			$xml=$1;
			print OUT $xml;
		}
}


foreach $x (@dirContents)
{
if ($x =~ /(id\d+)_xslSource/)
	 {
	 my ($xsl, $id,$number);
	 $id =$1;


	 	 	open XSL, $x;
		  read XSL, $xsl, 1000000;
			close XSL;
			
		
			$xsl=~s/<H3>.*?>(.*?)<.*?<\/H3>//s;
			$number = $1;
			$number =~ s/\D//g;
						
			print OUT "<a name='$id'>";

			print OUT "<BR><TABLE width='100%' border='0' cellspacing='0'><TR><TH class='inOneXSL'>&nbsp;&nbsp;&nbsp;<SPAN class='inOneXSL'>&nbsp;&nbsp;XSL $number&nbsp;&nbsp;</SPAN></TH>
			<TD class='inOneXSL'><A class='inOneXSL' href='#'>&nbsp;&nbsp;HOME&nbsp;&nbsp;</A> <A class='inOneXSL' href='#$xmlID'>&nbsp;&nbsp;XML&nbsp;&nbsp;</A> <A class='inOneXSL' href='#$id\_html'>&nbsp;&nbsp;HTML $number&nbsp;&nbsp;</A> <A class='inOneXSL' href='#$id\_output'>&nbsp;&nbsp;OUTPUT $number&nbsp;&nbsp;</A>&nbsp;&nbsp;&nbsp;</TD></TR></TABLE>";
			$1 =~ /(\d+)/;

			
			$xsl =~ /(<TABLE>.*<\/TABLE>)/s;
			$xsl=$1;
			$xsl=~s/target='COMMENT'/target='_blank'/g;
			print OUT $xsl;
			
			$x=~ s/xslSource/htmlSource/;
			
			my $htmlSource;
			open HTML, $x;
		  read HTML, $htmlSource, 1000000;
			close HTML;
			
			$htmlSource=~s/<H3>.*?<\/H3>//s;
			
			print OUT "<a name='$id\_html'>";
			print OUT "<BR><TABLE width='100%' border='0' cellspacing='0'><TR><TH class='inOneHTML'>&nbsp;&nbsp;&nbsp;<SPAN class='inOneHTML'>&nbsp;&nbsp;HTML $number&nbsp;&nbsp;</SPAN></TH>
			<TD class='inOneHTML'><A class='inOneHTML' href='#'>&nbsp;&nbsp;HOME&nbsp;&nbsp;</A> <A class='inOneHTML' href='#$xmlID'>&nbsp;&nbsp;XML&nbsp;&nbsp;</A> <A class='inOneHTML' href='#$id'>&nbsp;&nbsp;XSL $number&nbsp;&nbsp;</A> <A class='inOneHTML' href='#$id\_output'>&nbsp;&nbsp;OUTPUT $number&nbsp;&nbsp;</A>&nbsp;&nbsp;&nbsp;</TD>
			</TR></TABLE>";
			
			$htmlSource =~ /(<TABLE>.*<\/TABLE>)/s;
			$htmlSource=$1;
			print OUT $htmlSource;
			
			print OUT "<a name='$id\_output'>";
			print OUT "<BR><TABLE width='100%' border='0' cellspacing='0'><TR><TH class='inOneOUTPUT'>&nbsp;&nbsp;&nbsp;<SPAN class='inOneOUTPUT'>&nbsp;&nbsp;OUTPUT $number&nbsp;&nbsp;</SPAN></TH>
			<TD class='inOneOUTPUT'><A class='inOneOUTPUT' href='#'>&nbsp;&nbsp;HOME&nbsp;&nbsp;</A> <A class='inOneOUTPUT' href='#$xmlID'>&nbsp;&nbsp;XML&nbsp;&nbsp;</A> <A class='inOneOUTPUT' href='#$id'>&nbsp;&nbsp;XSL $number&nbsp;&nbsp;</A> <A class='inOneOUTPUT' href='#$id\_html'>&nbsp;&nbsp;HTML $number&nbsp;&nbsp;</A>&nbsp;&nbsp;&nbsp;</TD>
</TR></TABLE>";
			$x=~ s/_htmlSource//;
			my $html;
			open HTML, $x;
		  read HTML, $html, 1000000;
			close HTML;
			$html =~ /<BODY>(.*)<\/BODY>/s;
			$html=$1;
			print OUT $html;

			
		}
}

print OUT "</BODY></HTML>";

close OUT;
