use strict;
if ($ARGV[0] eq '') {print "EXIT. No book specified";exit;}	
my ($title, $creator, $size, $text,$ROOT, %authorsDatabase,$counter);
$size = 20;

openDatabases();

if (! open IN, "../Books/Sources/book$ARGV[0].xml") {print "ABORTED"; exit();}
read IN, $text, 1000000;
close IN;

{
my ($xmlSource);
$xmlSource = $text;
$xmlSource =~ s/</&lt;/g;
open SOURCE, ">../Books/Book$ARGV[0]/xmlSource.html";
print SOURCE "<HTML><BODY>
<P>This book was generated with a <A href='http://www.zvon.org/ZvonHTML/Downloads/listOfPrograms_en.html'>Perl script</A> from following source:</P>
<PRE>$xmlSource</PRE></BODY></HTML>";
close SOURCE;
}

mkdir "../Books/Book$ARGV[0]",755;

createMainFrame();
createMainToolbar();
createPositionFrame();

open BOOK, ">../Books/Book$ARGV[0]/book.html";
open TOOLBAR, ">../Books/Book$ARGV[0]/toolbar.html";

$text =~ /creator *= *[',"] *(.*?) *[',"]/;
$creator = $1;
$text =~ /<title *> *(.*?) *<\/title *>/;
$title = $1;
print BOOK "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		</HEAD>
		<BODY >
		<H3 class='CREATOR'>$authorsDatabase{$creator}{'name'}</H3>
		<H3 class='TITLE'><A href='#' target='_blank'/>$title</A><SUP><A href='xmlSource.html' style='color:red' target='_blank'>***</A></SUP></H3><TABLE>";

print TOOLBAR "
		<HTML>
		<HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<SCRIPT LANGUAGE='JavaScript'>
					book = new Array();
					\nchapterName = new Array();
";		

$counter= 0;
while($text=~/<chapter (.*?)>/sg)
{
	my ($content, $chapterName, @pages, $chapterURL);
	$counter++;
	
	$content = $1;
	$content =~ /name *= *[",'] *(.*?) *[",']/s;
	$chapterName = $1;
	$content =~ /pages *= *[",'] *(.*?) *[",']/s;
	@pages = split(/ /,$1);
	
	$chapterURL = $chapterName;
	$chapterURL =~ s/ /_/g;
	
	addToToolbar($counter,$chapterName, @pages);

	createChapterSummary($counter, $chapterName, @pages);
	
	print BOOK "<TR><TD><A class='CHAPTER' href='javascript:top.startChapter($counter)'>$chapterName <SUP><A target='XSL' href='javascript:top.summary($counter)'</A>sum</A></SUP></TD></TR>"; 
}

print BOOK "
</TABLE></BODY></HTML>
";

print TOOLBAR "
		</SCRIPT>
		</HEAD>
		<BODY>
		<IMG alt='TOC' lenght='$size' height='$size' src='../../Pictures/toc.jpg' border='0' onMouseDown='top.toc()'>
		<IMG alt='Previous' lenght='$size' height='$size' src='../../Pictures/previous.jpg' onMouseDown='top.previousExample()'>
		<IMG alt='Current' lenght='$size' height='$size' src='../../Pictures/current.jpg' onMouseDown='top.currentExample()'>
		<IMG alt='Next' lenght='$size' height='$size' src='../../Pictures/next.jpg' onMouseDown='top.nextExample()'>
		<IMG alt='Summary' lenght='$size' height='$size' src='../../Pictures/summary.jpg' onMouseDown='top.summary()'>
		<IMG alt='Keywords' lenght='$size' height='$size' src='../../Pictures/keywords.jpg' border='0' onMouseDown='top.keywordIndex()'>
		<img src='http://www.navrcholu.cz/cgi-bin/4web/nvhit.pl?id=00009880' width='1'  height='1' alt='' border='0'>
				
	</BODY></HTML>
				
	";
	close TOOLBAR;
sub addToToolbar
{
	my ($chapter, $page, $i, $summaryURL,$numberOfPages,$chapterName);
	
	
	$chapter = shift @_;
	
	$numberOfPages = $#_;
	$chapterName = shift @_;

	
	print TOOLBAR "
	\nbook[$chapter] = new Array();
	
	\nbook[$chapter][0] = $numberOfPages ;
	\nchapterName[$chapter] = '$chapterName';
	";
	
	$i=0;

	foreach $page (@_)
	{
			$i++;
		print TOOLBAR "\nbook\[$chapter]\[$i] = $page;";

	}
	print TOOLBAR "\ntotalChapters = $chapter;";
} #sub createToolbar

sub createMainFrame
 {
 	open FRAME, ">../Books/Book$ARGV[0]/index.html";
	print FRAME "
			<HTML>
			<HEAD>
			<TITLE>Zvon XSL Tutorial</TITLE>
			<SCRIPT  LANGUAGE='JavaScript'>
			example=1;
			chapter = 1;
			chapterPage=1;
			summaryURL='';

			exampleDir = '../Examples/Example';


		function authorIndex()
		{
			top.COMMENT.location.href='../../General/authors.html';
		}	
		
		function keywordIndex()
		{
			top.COMMENT.location.href='../../General/keywords.html';
		}
				
			function currentExample()
			{
							dir='../';
							dir=dir.concat(exampleDir);
							top.COMMENT.location.href= dir.concat(example,'/description.html');
							POSITION.update();					
			}
			
			
			
		function nextExample()
		{
		chapterPage++;

		if(chapterPage> TOOLBAR.book[chapter][0])	{
				chapter++;
		if(chapter>TOOLBAR.totalChapters)
		{
			contents();
			chapter--;
			chapterPage--;
			return;
		}
				chapterPage=1;
		}		

				example=TOOLBAR.book[chapter][chapterPage];
				currentExample();
		}
		
			
		function previousExample()
		{
		chapterPage--;
		if(chapterPage == 0){
		chapter--;
		
		if(chapter<1)
		{
			contents();
			chapter++;
			chapterPage++;
			return;
		}
		
		chapterPage=TOOLBAR.book[chapter][0];

}
		example=TOOLBAR.book[chapter][chapterPage];
				currentExample();

		}
		
				
		function startChapter(number)
		{
						chapter = number;
						chapterPage=1;
						example=TOOLBAR.book[chapter][chapterPage];
    				currentExample();
	}
		
		function summary(number)
		{
						if(number) number=number;
						else number=chapter;
						
						url='summary';
						top.COMMENT.location.href=url.concat(number,'.html') ;
		}
		
		function contents()
		{
			top.XSL.location.href= '../../Books/Book$ARGV[0]/book.html';
		}
			
		function callExample(number)
			{
							if(number>0) example=number;
            currentExample(); 
						/*	top.COMMENT.location.href= exampleDir.concat(example,'/description.html'); */
			}
			
			function tut()
		{
			top.location.href='http://www.zvon.org/ZvonHTML/Zvon/zvonTutorials_en.html';
		}
			
				function toc()
		{
			exampleDir = '../Examples/Example';

			top.STYLESHEET_SELECTION.location.href='mainToolbar.html';
			top.COMMENT.location.href='../../General/keywords.html';
			top.XML.location.href='../../General/examples.html';
			top.HTML.location.href='../../General/about.html';
			top.OUTPUT.location.href='../../General/help.html';
			top.XSL.location.href='book.html';
		}
			
			</SCRIPT>
			</HEAD>
			<FRAMESET  NAME= 'INDEX' COLS='25%,30%,45%' >
				<FRAMESET ROWS='50,*'>
					<FRAME SRC='toolbar.html' NAME='TOOLBAR' scrolling='no'>
					<FRAME SRC='../../General/keywords.html' NAME='COMMENT' >		
			</FRAMESET>
			<FRAMESET ROWS='50,33%,33%,33%'>
				<FRAME SRC='position.html' NAME='POSITION' scrolling='no'>
				<FRAME SRC='../../General/examples.html' NAME='XML' >
				<FRAME SRC='../../General/about.html' NAME='HTML' >
  			<FRAME SRC='../../General/help.html' NAME='OUTPUT' >
			</FRAMESET>
			<FRAMESET ROWS='50,*'>
			<FRAME SRC='mainToolbar.html' NAME='STYLESHEET_SELECTION' >			
			<FRAME SRC='book.html' NAME='XSL'  >
			</FRAMESET>
		</FRAMESET>
		</HTML>";
	close FRAME;
}#sub createMainFrame

sub createMainToolbar
{
	open OUT, ">../Books/Book$ARGV[0]/mainToolbar.html";
	print OUT "
		<HTML>
		<HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		</HEAD>
		<BODY>
		<IMG alt='Keywords' lenght='$size' height='$size' src='../../Pictures/keywords.jpg' border='0' onMouseDown='top.keywordIndex()'>
		<IMG alt='Authors' lenght='$size' height='$size' src='../../Pictures/authors.jpg' border='0' onMouseDown='top.authorIndex()'>
		<IMG alt='Zvon tutorials' lenght='$size' height='$size' src='../../Pictures/tut.jpg' border='0' onMouseDown='top.tut()'>
				
	</BODY></HTML>
				
	";
	close OUT;
}

sub openDatabases  #same in generateIndexes
{
	my (@creators, $data, $cr,$email);

	open IN, "../Databases/authors.db";
	read IN, $data, 1000000;
	close IN;
	
	@creators = split (/<\/creator/sg,$data);  #>


	foreach $cr (@creators)
	{
		if ($cr=~/<email *> *(.*?) *<\/email *>/s)
		{
			$email = $1;
			$cr=~/<creator .*?zvonID *= *[',"](.*?)[',"]/s;
			$authorsDatabase{$email}{'zvonID'} = $1;
			$cr=~/<name *> *(.*?) *<\/name *>/s;
			$authorsDatabase{$email}{'name'} = $1;
		}
	}#foreach
	
}#openDatabases

sub	createChapterSummary
{
	my($number, $title, $i,$ch);
	
	$number = shift(@_);
  $title = shift(@_);

  open SUMMARY, ">../Books/Book$ARGV[0]/summary$number.html";
	
	print SUMMARY "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3 class='TITLE'><A href='#' target='_blank'/>$title</A></H3>";			

		$i = 1;
	foreach $ch (@_)
		{
				my($text,$description);
				open IN, "../ExampleSources/example$ch.xml";
				read IN,$text,5000000;
				close IN;
				
				$text =~ /<description\s*>\s*(.*?)\s*<\/description/s;
				$description = $1;
				$description =~ s/<stylesheet.*?\/>/<B>This stylesheet<\/B>/g;
				$description =~ s/<example.*?id\s*=\s*["']\s*\w*?(\d+).*?\/>/<A class='exNumber' HREF='javascript:top.callExample($1)'>Example $1<\/A>/g;
				
				print SUMMARY "<DIV><A class='exNumber' HREF='javascript:top.chapter=$number; top.chapterPage=\"$i\";top.callExample($ch);'>[Example $ch]</A> <A  class='CREATOR' href='javascript:top.contents()' target='XSL'>&lt;C&gt;</A></DIV><P>$description</P>";

			$i++;
		}
	
	print SUMMARY "</BODY></HTML>";
	close SUMMARY;

}# createChapterSummary

sub createPositionFrame
{


	open OUT,  ">../Books/Book$ARGV[0]/position.html";
 print OUT "
 		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<SCRIPT LANGUAGE='JavaScript'>
		function update()
{
	document.forms[0].title.value =  top.TOOLBAR.chapterName[top.chapter];
	pos = '';
	pos = pos.concat(top.chapterPage,'/',top.TOOLBAR.book[top.chapter][0]);
	document.forms[0].page.value = pos;
}
</SCRIPT>
		</HEAD>
		<BODY class='ST'>
		<FORM >
		<INPUT type='text' size='22' name='title' readonly>
		<INPUT type='text' size='4' name='page' readonly>
		</FORM>
		</BODY></HTML>
		";
	close OUT;
}