use strict;

if ($ARGV[0] eq '') {print "EXIT. No example specified";exit;}
my (%authorsDatabase,$creator, $XSL_ENGINE,$exampleText, @xslTags, @xslAttributes,%value,$description,$xslSource,$xmlFile,$xmlSourceFile,$xslFile, $htmlFile, $htmlSourceFile, $startXslSourceFile, $xmlSource, $i, $exampleDir, @xslFunctions, @xslAxes);

@xslFunctions=('namespace-uri', 'current', 'generate-id', 'last','substring','substring-before','translate','substring-after','local-name','name','count','position','sum','text',
'true','false','round', 'ceiling', 'floor','number','boolean','not','lang','string','concat','starts-with','contains','normalize-space','string-length','id');
@xslAxes = (  'ancestor', 'ancestor-or-self', 'attribute', 'child', 'descendant', 'descendant-or-self', 'following','following-sibling', 'namespace','parent', 'preceding', 'preceding-sibling', 'self');
############USER  AREA#############################################
$XSL_ENGINE = 'c:\q\jre\bin\java -cp c:\q\xt\xt.jar;c:\q\xp\xp.jar com.jclark.xsl.sax.Driver';
##############################END OF USER AREA#######################

#####input xm file to process########################
if (! open IN, "../ExampleSources/example$ARGV[0].xml") {print "ABORTED"; exit();}
read IN, $exampleText, 5000000;
close IN;


##############################################

openDatabases();

assignParametersForXSLsourceProcessing();
createExampleDirectory();
createAndStartDescriptionFile();
cretateAndStartXMLFiles();
cretateAndStartXSLFiles();
postprocessXSLsourceOutput();
finishDescriptionFile();
finishXMLFiles();

chdir "../Examples/Example$ARGV[0]";
opendir DIR, ".";
my($d);

foreach $d (readdir DIR)
{
if($d=~/id\d+\.html/) 
{
my $temp;
open IN, $d;
read IN, $temp, 1000000;
close IN;
open OUT, ">$d";
print OUT "
<HTML><HEAD>
</HEAD>
<BODY>
$temp
</BODY>
</HTML>
";
close OUT;
}
}

chdir "../../Perl";
system "perl exampleInOne.pl $ARGV[0]";

sub  assignParametersForXSLsourceProcessing
 {
 my($attValues, $name, $i, $j, $file, @files);

		opendir DIR, "../Definitions";
		@files = readdir(DIR);
	
	$i=0;$j=0;
	
	foreach $file (@files)
	{
		if ($file=~/(.*?)\.html/)	{
			$name=$1;
			$name =~ s/__/:/g;
			$name =~ s/_/-/g;
			
			if ($name=~/^xsl:/)
				{
					$xslTags[$i++]=$name;
				}#if
					else
			{
				@xslAttributes[$j++] = $name;
			}#else
			
		}	#if
		

	} #foreach
		
		$exampleText =~ /<attValues *?>(.*?)<\/attValues/s;
		$attValues = $1;

		while ($attValues =~ /<value.*?match\s*=\s*["']\s*(.*?)\s*?["'].*?>(.*?)<\/value/sg)
		{
		$value{$1}=$2;
		} #while
 }#sub  assignParametersForXSLsourceProcessing
 
 sub createExampleDirectory
 {
 my ($tmp);
	 $exampleDir = "Example$ARGV[0]";

	 mkdir ("../Examples/$exampleDir",777);
	 
	 $tmp = $exampleText;
	 $tmp=~ s/</&lt;/g;
	 $tmp=~ s/\n/<BR>/g;
	 $tmp=~s/\t/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/g;
	 $tmp=~s/ /&nbsp;/g;
	 
	 open OUT,">../Examples/$exampleDir/exampleSource.html";
	 print OUT $tmp;
	 close OUT;

	 open STYLESHEETS_TOOLBAR, ">../Examples/$exampleDir/stylesheetsSelection.html";
	 print STYLESHEETS_TOOLBAR "
	 <HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY class='ST'>
		";
 }#  sub createExampleDirectory
 
 sub createAndStartDescriptionFile
 {
	open DESCRIPTION, ">../Examples/$exampleDir/description.html";
	$exampleText =~ /creator\s*=\s*['"]\s*(.*?)\s*['"]/;
	$creator = $1;
	
	$exampleText =~ /<description>(.*)<\/description>/s;
	$description = $1;
	$description =~ s/<stylesheet\s*id\s*=\s*["']\s*(\w*)\s*["']\s*\/>/<a target='XSL' href='$1\_xslSource.html'>XXX$1\XXX<\/a>/gs;

	$description =~ s/<example\s*id\s*=\s*["']\s*\w*?(\d+)\s*["']\s*\/>/<A class = 'exNumber' HREF='..\/..\/Examples\/Example$1\/description.html'>Example $1<\/A>/gs;
 }#sub createAndStartDescriptionFile
 
  sub cretateAndStartXMLFiles
 {
 my ($xml,$dtd,$topAttributes,$source);
 	$exampleText =~ /<xmlSource\s*id\s*=\s*["']\s*(\w*)\s*["']\s*>(.*?)<\/xmlSource>/gs;
	$xmlFile = "$1.xml";
	$xmlSourceFile = "$1\_xmlSource.html";
	open XML_SOURCE, ">../Examples/$exampleDir/$xmlSourceFile";
	open XML, ">../Examples/$exampleDir/$xmlFile";
	$source = $2;
	
	if ($exampleText =~ /<dtd\s*>\s*(.*?)\s*<\/dtd\s*>/s)
	{	
	$dtd = "<!DOCTYPE xslTutorial  [
<!ELEMENT xslTutorial ANY>
$1]>\n";
}
	if ($exampleText =~ /<topAttributes\s*>\s*(.*?)\s*<\/topAttributes\s*>/s)
	{	
$topAttributes = $1;
}

	$xml = "<?xml version=\"1.0\"?>\n$dtd<xslTutorial $topAttributes>\n$source</xslTutorial>";
	print XML $xml;
	close XML;	

	$xmlSource = $xml;
	$xmlSource  =~ s/</\&lt\;/g;
	$xmlSource =~ s/\n/\n<\/TD><\/TR><TR><TD>/g;

 } #sub cretateAndStartXMLFiles
 
 
 sub  cretateAndStartXSLFiles
{
	$i = 1;
while ($exampleText =~ /<xslStylesheet\s*id=\s*["']\s*(\w*)\s*["']\s*>(.*?)<\/xslStylesheet>/gs)
{
my ($xslSourceFile, $xslText,$xsl, $xmlns);

$xslFile = "$1.xsl";
$htmlFile =  "$1.html";
$xslSourceFile = "$1\_xslSource.html";
$htmlSourceFile = "$1\_htmlSource.html";
$xslText = $2;

$xmlns = '';
while ($xslText =~ /<xmlns\s*>\s*(.*)\s*<\/xmlns/gs)
{
	$xmlns = "$xmlns  version='1.0' xmlns:$1";
}

###replace eventual reference to a stylesheet with its name##  
$description =~ s/XXX$1XXX/Stylesheet $i/g;
###########################################


if ($i == 1) { 
		$startXslSourceFile = $xslSourceFile;
		}#if

open XSL, ">../Examples/$exampleDir/$xslFile";
open XSL_SOURCE, ">../Examples/$exampleDir/$xslSourceFile";
############add  stylesheet to the stylesheet toolbar ################
print STYLESHEETS_TOOLBAR  "<A target='XSL' class='ST' href='$xslSourceFile'>$i</A> ";
#######################################################################

print XSL_SOURCE "
<HTML><HEAD>
<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
</HEAD><BODY onLoad='focus();top.HTML.location.href=\"$htmlSourceFile\"'>
<TABLE><TR><TD>
<H3><a href='#' target='_blank'>XSL  stylesheet $i</a></H3>";



$xsl = "<xsl:stylesheet  version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform\' $xmlns>\n$xslText</xsl:stylesheet>";

$xsl =~ s/<xmlns\s*>.*?<\/xmlns\s*>//sg;
print XSL $xsl ;
close XSL;

$xslSource = $xsl;
postprocessXSLsourceOutput();

 print XSL_SOURCE $xslSource;
 print XSL_SOURCE "</TD></TR></TABLE></BODY></HTML>";
 close XSL_SOURCE ;
 
 createHtmlSource();
	$i++
	}#while
	
print STYLESHEETS_TOOLBAR "</BODY></HTML>";
close STYLESHEETS_TOOLBAR;
}# sub  cretateAndStartXSLFiles


sub postprocessXSLsourceOutput
{
my($tag, $att,$key, $val, $j, $function,$axis);

$xslSource  =~ s/\&/\&amp;/g;
$xslSource  =~ s/</\&lt\;/g;
$xslSource =~ s/\n/\n<\/TD><\/TR><TR><TD>/g;

foreach $tag (@xslTags)
{
	my ($address,$link);	
	$address = $tag;
	$address =~ s/:/__/g;
	$address =~ s/-/_/g;
	$link = "<a class='TAG' target='COMMENT' HREF='../../Definitions/$address.html'>$tag</a>";
	$xslSource =~ s/$tag([ \/>])/$link$1 /g;
}

foreach $att (@xslAttributes)
{	
my($link, $address);
	$address = $att;
	$address =~ s/:/__/g;
	$address =~ s/-/_/g;
	$link = "<a class='ATT' target='COMMENT' HREF='../../Definitions/$address.html'>$att</a>";
	
$xslSource =~ s/(<.*? )\Q$att\E(\s*=)(.*?>)/$1$link$2$3/g;
}

$j = 1;
while ( ($key, $val) = each %value) {
my ($link);
open VAL, ">../Examples/$exampleDir/val$j.html";
print VAL "<HTML><HEAD><link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
</HEAD><BODY>";
print VAL "<H3><a class='VALUE' href='#' target='_blank'>$key</a></H3><P>$val</P>";
print VAL "</BODY></HTML>";
close VAL;

$link = "<a class='VALUE' target='COMMENT' href='val$j.html'>$key</a>";
	$xslSource =~ s/(["'] *?)\Q$key\E( *?["'])/$1$link$2/g;
	
$j++;
}

foreach $function  (@xslFunctions)
{
	my ($address,$link);	
	$address = $function;
	$address =~ s/:/__/g;
	$address =~ s/-/_/g;
	$link = "<a class='FUNCTION' target='COMMENT' href='../../Definitions/$address.html'>$function</a>";
	$xslSource =~ s/$function *\(/$link(/g;
}

foreach $axis  (@xslAxes)
{
	my ($address,$link);

	$address = "$axis\::";
	$address =~ s/:/__/g;
	$address =~ s/-/_/g;
	$link = "<a class='AXIS' target='COMMENT' href='../../Definitions/$address.html'>$axis</a>";

	$xslSource =~ s/$axis\s*::/$link\::/g;
}

}#sub postprocessXSLsourceOutput

sub createHtmlSource
{
my($html);

chdir "../Examples/Example$ARGV[0]";
system "$XSL_ENGINE $xmlFile $xslFile $htmlFile";

open IN, "$htmlFile";
read IN, $html,1000000;
close IN;

chdir "../../Perl";
$html =~ s/\&/\&amp;/g;
$html =~ s/<\//\&lt\;\//g;
$html =~ s/</\n<\/TD><\/TR><TR><TD>\n\&lt\;/g;

open OUT, ">../Examples/$exampleDir/$htmlSourceFile";

print OUT "<HTML><HEAD><link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
</HEAD><BODY onLoad='top.OUTPUT.location.href=\"$htmlFile\"'><TABLE><TR><TD>";
print OUT "<H3><a href='#' target='_blank'>HTML output $i</a></H3>";
print OUT $html;
print OUT  "</TD></TR></TABLE></BODY></HTML>";
close OUT;
}#sub createHtmlSource

sub finishDescriptionFile
{
	print DESCRIPTION "<HTML><HEAD><link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
</HEAD><BODY onLoad='focus();top.XML.location.href=\"$xmlSourceFile\";top.STYLESHEET_SELECTION.location.href=\"stylesheetsSelection.html\"'><TABLE><TR><TH>
<A href='mailto:$creator'>$authorsDatabase{$creator}{'name'}</A><BR>
<A href='#' target='_blank' class='TAG'>Example $ARGV[0]</A><SUP><A class='srcXML' target='_blank'  HREF='exampleSource.html'>***</A></SUP></TH></TR><TR><TD>";
print DESCRIPTION $description;
print DESCRIPTION "</TD></TR></TABLE></BODY></HTML>";
close DESCRIPTION;
}#sub finishDescriptionFile

sub finishXMLFiles
{
$xmlSource =~ s/ /&nbsp;/g;
	print  XML_SOURCE "<HTML><HEAD><link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
</HEAD><BODY onLoad='top.XSL.location.href=\"$startXslSourceFile\"'><TABLE><TR><TD>";
print  XML_SOURCE "<H3><a href='#' target='_blank'>XML source</a></H3>";
 print  XML_SOURCE $xmlSource;
 print  XML_SOURCE  "</TABLE></BODY></HTML>";
 close  XML_SOURCE;
}#sub finishXMLFiles

sub openDatabases  #same in generateIndexes
{
	my (@creators, $data, $cr,$email);
	open IN, "../Databases/authors.db";
	read IN, $data, 1000000;
	close IN;
	
	@creators = split (/<\/creator/sg,$data);  #>


	foreach $cr (@creators)
	{
		if ($cr=~/<email *> *(.*?) *<\/email *>/s)
		{
			$email = $1;
			$cr=~/<creator .*?zvonID *= *['"](.*?)['"]/s;
			$authorsDatabase{$email}{'zvonID'} = $1;
			$cr=~/<name *> *(.*?) *<\/name *>/s;
			$authorsDatabase{$email}{'name'} = $1;
		}
	}#foreach
	
}#openDatabases