use strict;

my ($size,$XSL_ENGINE, @files, $file, $text, $exampleNumber, @examples, %keywords, %authors, %authorsDatabase, $i);
$size = 20;
############USER  AREA#############################################
$XSL_ENGINE = 'c:\q\jre\bin\java -cp c:\q\xt\xt.jar;c:\q\xp\xp.jar com.jclark.xsl.sax.Driver';
##############################END OF USER AREA#######################

	aboutFile();
	helpFile();
	opendir DIR, "../ExampleSources";
	@files = readdir(DIR);
	
	$i=0;
	
	foreach $file (@files)
	{
		if ($file=~/example(.*?)\.xml/)	{
			
			$exampleNumber = $1;
			$examples[$i] = $exampleNumber;
			open IN, "../ExampleSources/$file";
			read IN, $text, 1000000;
			close IN;
			
			authorIndex();
			keywordIndex();

		}	#if
		
		$i++;
	}#foreach
 @examples = sort  {$a <=> $b} (@examples);
 printIndexes();

 system "perl indexesInOne.pl";
 
 
sub authorIndex
{
$text =~ /<xslTutorial (.*?)>/s;
$1 =~ /creator *= *[',"] *(.*?) *[',"]/;
$authors{$1} = "$authors{$1}::$exampleNumber";


} #sub authorIndex

sub keywordIndex
{	
	my (@keys, $k);
	if ($text !~ /<index *keywords *= *[',"] *(.*?) *[',"]/s) {return;}; 
	@keys = split(/ +/,$1);
	
	foreach $k (@keys)
	{	
		$keywords{$k} = "$keywords{$k}::$exampleNumber";
	}
	

} #sub keywordIndex

sub printIndexes
{
###EXAMPLES####
		openDatabases();
		my ($ex, $key, $value);
	 	open EX, ">../General/examples.html";
		print EX "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3><A href='#' target='_blank'/>List of examples</A></H3>";
		
		foreach $ex (@examples)
		{ 
		print  EX "<A class = 'exNumber' href='../Examples/Example$ex/description.html'>$ex</A>\n";
		} #foreach
		
		print EX "</BODY></HTML>";
	close EX;		
###AUTHORS######	
	open AU,  ">../General/authors.html";
			print AU "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3><A href='#' target='_blank'/>Author index</A></H3>
		<TABLE>
		";
	
	while (($key,$value) = each %authors)
	{
		my (@val, $v);
		print AU "<TR><TH>$authorsDatabase{$key}{'name'}:</TH></TR><TR><TD>";
		@val = split (/::/,$value);
		shift @val;
		@val = sort  {$a <=> $b} (@val);
		foreach $v (@val)
		{
			print AU "<A class = 'exNumber' href='../Examples/Example$v/description.html'>$v</A> ";
		}#foreach
		
		print AU "</TD></TR>";


	}# while
			print AU "</TABLE></BODY></HTML>";
	close AU;
	
	
####keywords
	
	open KEY,  ">../General/keywords.html";
			print KEY "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3><A href='#' target='_blank'/>Keywords</A></H3>
		<TABLE>
		";
		
	my (@keys);	
	@keys = sort keys %keywords;  
	foreach $key (@keys)
	{
		my (@val, $v);
		print KEY "<TR><TD>$key: ";
		@val = split (/::/,$keywords{$key});
		shift @val;
				@val = sort  {$a <=> $b} (@val);
		foreach $v (@val)
		{
			print KEY "<A class = 'exNumber' href='../Examples/Example$v/description.html'>$v</A> ";
		}#foreach
		
		print KEY "</TD></TR>";


	}# while
			print KEY "</TABLE></BODY></HTML>";
	close KEY;
 
}

sub openDatabases #same in generateBook
{
	my (@creators, $data, $cr,$email);
	open IN, "../Databases/authors.db";
	read IN, $data, 1000000;
	close IN;
	
	@creators = split (/<\/creator/sg,$data);  #>


	foreach $cr (@creators)
	{
		if ($cr=~/<email *> *(.*?) *<\/email *>/s)
		{
			$email = $1;
			$cr=~/<creator .*?zvonID *= *[',"](.*?)[',"]/s;
			$authorsDatabase{$email}{'zvonID'} = $1;
			$cr=~/<name *> *(.*?) *<\/name *>/s;
			$authorsDatabase{$email}{'name'} = $1;
		}
	}#foreach
	
}#openDatabases

sub aboutFile
{
open ABOUT,  ">../General/about.html";
			print ABOUT "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3><A href='#' target='_blank'/>About...</A></H3>
		<TABLE>
		<TR><TH> This program was written as a part of <A target='_blank' href='http://www.zvon.org:/ZvonHTML/Zvon/zvonHomepage_en.html'>Zvon project</A>.</TH></TR> 
<TR><TH>Author: <A href='mailto:nicmila\@idoox.com'>Miloslav Nic</A></TH></TR>
		</TABLE>
		</BODY>
		</HTML> 
		";
		
		close ABOUT;

}

sub helpFile
{
open HELP,  ">../General/help.html";
			print HELP "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../CSS/tutorial.css'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3><A href='#' target='_blank'/>HELP AND HOW TO CONTRIBUTE</A></H3>

<P>Click on the title to open Help in a new window. This is a general behaviour of all windows. <a href='http://www.zvon.org:/ZvonHTML/Downloads/zvonXSLTutorial_en.html' target='_blank'>You can download entire tutorial</A></P>
<p>Software can simplify some tasks both for authors and for readers. But contents is more important than data. Please help to build a valuable resource for XSL community.<a href='#contribute'>Help both from experienced XSL programmers and novices in the field is very important. </a>
</p>
<p>The program needs some polishing, but most functions are already here. The Help file is in this moment rudimental, it will be rewritten when time permits.  
</p>
<p>Hyperlink texts are not underlined, but they are colored and differ substantialy from its surrounding. The behaviour of the links depends on context. They can open an email message to the author of example or book, click on a title will open a new window with the contents of given frame, click in XSL source frame will display explanation in left frame, click on example number will open the example.
</p>
<p>A click on the button <IMG lenght='$size' height='$size' src='../Pictures/toc.jpg' border='0'> in upper left window reloads start page of the program. 
</p>
<A name='contribute'><H2>How to contribute</H2>
<ul>
<li><A href='#example'>Write an example</A>
<li><A href='#book'>Create a book</A>
</ul>
<p>If you want to contribute, please send me an email (<a href='mailto:nicmila\@idoox.com'>nicmila\@idoox.com</a>) with your example or book file (either inside the text or as an attachement). I will process the file and publish it on the <A href='http://www.zvon.org:/ZvonHTML/Zvon/zvonHomepage_en.html'>Zvon website</A>. This mechanism will change in the future but it seems to be reasonable in initial stage of the project. 
</p>
<p> When I started to write this program I had two basic ideas. It occured to me that it would be very useful for a novice or for someone who wants to learn a new feature, if he/she can look at source file, XSL stylesheet and output at the same moment. I am a strong believer in 'teaching by examples', a minimal necessary explanation and a lot of examples is better than a long story sprinkled with a few examples. 
</p>
<p>But I am not an expert in the field and I am not even longing to become one. For myself XSL and few other standards like XML or HTML are just very useful tools which help me in my own areas of interest. On the other hand if people acquire at least basic skills with such tools, it will help me a lot in my future projects.   
</p>
<p>So although I plan to contribute to the examples pool, I am aware of the fact that I can only scratch the full potential of such a system.
</p>
<p>And there was my second idea. There are nowadays some real experts, who can realy teach some cool ways how to do things and there is a lot of newcomers who are now struggling their ways through XSL jungle.  And a novice or an average user can often provide a better help for a beginner than an expert who is mentally too far ahead. So both novices and experts are useful in tutorial writting.
</p>
<p>If there was some simple mechanism how to share our common knowledge pool, it would be of great help to many of us. Well, I hope I have found quite a decent one. 
</p>
<A name='example'><H3>Write an example</H3>
<p>An example is a building block of the system. The example consist of short description, XML sample and one or several XSL stylesheets. All is provided in one XML file. A parser reads the file and generates all necessary files for publication. As the output files are generated, we can be sure that all sources really corresponds each to other.
</p>
<p>The DTD for input file is shown below. I actually do not validate input, as I have tags inside xmlSource and xslStylesheet elements and I do not want to mess with CDATA sections. But at least it is a convenient form of documentation.
</p>

<pre>
 
 &lt;!ELEMENT xslTutorial (index?,description,xmlSource, attValues?,xslStylesheet+)>
 &lt;!ATTLIST xslTutorial
 								creator CDATA #REQUIRED>
 
 &lt;!ELEMENT index EMPTY>
 &lt;!ATTLIST index
 						keywords CDATA #REQUIRED>
						
 &lt;!ELEMENT description (#PCDATA|stylesheet)*>
 &lt;!ELEMENT xmlSource ANY>
 &lt;!ATTLIST xmlSource
 								id ID #REQUIRED>
								
 &lt;!ELEMENT xslStylesheet ANY>
 &lt;!ATTLIST xslStylesheet
 								id ID #REQUIRED>		
		
	&lt;!ELEMENT stylesheet EMPTY>
	&lt;!ATTLIST stylesheet
					 	id IDREF #REQUIRED>						

&lt;!ELEMENT attValues (value)*>
&lt;!ELEMENT value (#PCDATA)>
&lt;!ATTLIST value
						match CDATA #REQUIRED>						

						</pre>

<p>The root element is xslTutorial and creator attribute tracks the author of the example. I consider very important the fact that each example has its author quoted. According to my view everybody who contributes to such a project should be given proper credit and in the same time it should improve quality of the entries if authors are not anonymous. 
</p>						
<p>Optional index element gives the author the opportunity to specify which keywords are especially pertinent to the example. From these keywords the Keywords index on the front page is generated.  
</p>
<p>A description is shown in the left frame when an example is displayed. The optional stylesheet element is in output replaced by link to stylesheet specified with id attribute.
</p>
<p>Element attValues makes specified data clickable in XSL stylesheet display. While name of XSL elements and attributes can be generated automatically, the values are to diverse to provide a universal mechanism.
</p>
<p>xmlSource and xslStylesheet contain the actual examples. The starting tags are generated automatically.
</p>
<p>And this is the source from whih  example 1 was generated
</p>
<pre>
&lt;xslTutorial creator=\"nicmila\@idoox.com\">
&lt;index keywords='// /'/>

&lt;description>With XSL you can freely modify any source text. &lt;stylesheet id=\"id4\"/> and &lt;stylesheet id=\"id5\"/> produce different output from the same source file.&lt;/description>

&lt;example id=\"id1\">
&lt;xmlSource id=\"id3\">
&lt;title>XSL&lt;/title>
&lt;author>John Smith&lt;/author>
&lt;/xmlSource>

&lt;attValues>
&lt;value match=\"//title\">matches any title element anywhere in the document.
&lt;/value>
&lt;value match=\"//author\">matches any author element anywhere in the document.
&lt;/value>
&lt;value match=\"/\">matches the root element.
&lt;/value>
&lt;/attValues>

&lt;xslStylesheet id=\"id4\">
&lt;xsl:template match=\"/\"> 
&lt;H1>&lt;xsl:value-of select=\"//title\"/>&lt;/H1>
&lt;H2>&lt;xsl:value-of select=\"//author\"/>&lt;/H2>
&lt;/xsl:template>
&lt;/xslStylesheet>

&lt;xslStylesheet id=\"id5\">
&lt;xsl:template match=\"/\">
&lt;H2>&lt;xsl:value-of select=\"//author\"/>&lt;/H2>
&lt;H1>&lt;xsl:value-of select=\"//title\"/>&lt;/H1>
&lt;/xsl:template>
&lt;/xslStylesheet>

&lt;/example>
&lt;/xslTutorial>
</pre>

<A name='book'><H3>Create a book</H3>
<p>Examples are a very useful, but if you want to really explain anything, they are not sufficient. At the same time, it would be very helpful, if examples could be recycled in different context. With this software you can form chapters from individual examples and books from chapters. 
</p>
<p>Entire book is also specified in a XML file. The following paragraph shows a prototype. In this case a book with name Introduction to XSL is created. Contents of the book appears in the right frame of start Page. The numbers give numbers of individual examples to be used in a chapter.  I hope that the format is self-explanatory. I will provide further details when matters become more complicated.
</p>
<pre>
&lt;book creator='nicmila\@idoox.com'>
&lt;title>Introduction to XSL&lt;/title>
&lt;chapter name='Introduction' pages='1 4'/>
&lt;chapter name='Advanced features' pages='5 6 7 5'/>
&lt;chapter name='END' pages='2 3 2'/>

&lt;/book>
</pre>
		</BODY>
		</HTML>";
		
		close HELP;

}