use strict;
if ($ARGV[0] eq '') {print "EXIT. No book specified";exit;}	
my ($title, $creator, $size, $text,$ROOT, %authorsDatabase,$counter);
$size = 20;

openDatabases();

if (! open IN, "../Books/Sources/book$ARGV[0].xml") {print "ABORTED"; exit();}
read IN, $text, 1000000;
close IN;


mkdir "../Books/Book$ARGV[0]",755;

createMainFrame();
createMainToolbar();
createPositionFrame();

open BOOK, ">../Books/Book$ARGV[0]/book.html";
open TOOLBAR, ">../Books/Book$ARGV[0]/toolbar.html";

$text =~ /creator *= *['"] *(.*?) *['"]/;
$creator = $1;
$text =~ /<title *> *(.*?) *<\/title *>/;
$title = $1;
print BOOK "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		</HEAD>
		<BODY >
		<H3 class='CREATOR'>$authorsDatabase{$creator}{'name'}</H3>
		<H3 class='TITLE'><A href='#' target='_blank'/>$title</A></H3><TABLE>";

print TOOLBAR "
		<HTML>
		<HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<SCRIPT LANGUAGE='JavaScript'>
					book = new Array();
					\nchapterName = new Array();
";		

$counter= 0;
while($text=~/<chapter (.*?)>/sg)
{
	my ($content, $chapterName, @pages, $chapterURL);
	$counter++;
	
	$content = $1;
	$content =~ /name *= *[",'] *(.*?) *[",']/s;
	$chapterName = $1;
	$content =~ /pages *= *[",'] *(.*?) *[",']/s;
	@pages = split(/ /,$1);
	
	$chapterURL = $chapterName;
	$chapterURL =~ s/ /_/g;
	
	addToToolbar($counter,$chapterName, @pages);

	createChapterSummary($counter, $chapterName, @pages);
	
	print BOOK "<TR><TD><A class='CHAPTER' href='javascript:top.startChapter($counter)'>$chapterName </TD></TR>"; 
}

print BOOK "
</TABLE></BODY></HTML>
";

print TOOLBAR "
		</SCRIPT>
		</HEAD>
		<BODY>
		<TABLE>
		<TR><TD style='vertical-align:top'>
		<IMG lenght='$size' height='$size' src='../../Pictures/toc.jpg' border='0' onMouseDown='top.toc()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/book.jpg' border='0' onMouseDown='top.book()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/summary.jpg' onMouseDown='top.summary()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/previous.jpg' onMouseDown='top.previousExample()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/current.jpg' onMouseDown='top.currentExample()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/next.jpg' onMouseDown='top.nextExample()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/keywords.jpg' border='0' onMouseDown='top.keywordIndex()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/authors.jpg' border='0' onMouseDown='top.authorIndex()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/tut.jpg' border='0' onMouseDown='top.tut()'>
		</TD><TD class='ST'>
		<FORM >
		<INPUT type='text' size='40' name='title' readonly>
		<INPUT type='text' size='6' name='page' readonly>
		</FORM>
		</TD></TR></TABLE>
				
	</BODY></HTML>
				
	";
	close TOOLBAR;
sub addToToolbar
{
	my ($chapter, $page, $i, $summaryURL,$numberOfPages,$chapterName);
	
	
	$chapter = shift @_;
	
	$numberOfPages = $#_;
	$chapterName = shift @_;

	
	print TOOLBAR "
	\nbook[$chapter] = new Array();
	
	\nbook[$chapter][0] = $numberOfPages ;
	\nchapterName[$chapter] = '$chapterName';
	";
	
	$i=0;

	foreach $page (@_)
	{
			$i++;
		print TOOLBAR "\nbook\[$chapter]\[$i] = $page;";

	}
	print TOOLBAR "\ntotalChapters = $chapter;";
} #sub createToolbar

sub createMainFrame
 {
 	open FRAME, ">../Books/Book$ARGV[0]/index.html";
	print FRAME "
			<HTML>
			<HEAD>
			<TITLE>Zvon CSS Tutorial</TITLE>
			<SCRIPT  LANGUAGE='JavaScript'>
			example=1;
			chapter = 1;
			chapterPage=1;
			summaryURL='';

			exampleDir = '../Examples/Example';


		function authorIndex()
		{
			top.HTMLSOURCE.location.href='../../General/authors.html';
		}	
		
			function book()
		{
			top.HTMLOUTPUT.location.href='book.html';
		}	
		
		function keywordIndex()
		{
			top.HTMLSOURCE.location.href='../../General/keywords.html';
		}
				
			function currentExample()
			{
							dir='../';
							dir=dir.concat(exampleDir);
							top.COMMENT.location.href= dir.concat(example,'/description.html');
							update();					
			}
			
function update()
{
	top.TOOLBAR.document.forms[0].title.value =  top.TOOLBAR.chapterName[top.chapter];
	pos = '';
	pos = pos.concat(top.chapterPage,'/',top.TOOLBAR.book[top.chapter][0]);
top.TOOLBAR.document.forms[0].page.value = pos;
}
			
		function nextExample()
		{
		chapterPage++;

		if(chapterPage> TOOLBAR.book[chapter][0])	{
				chapter++;
		if(chapter>TOOLBAR.totalChapters)
		{
			contents();
			chapter--;
			chapterPage--;
			return;
		}
				chapterPage=1;
		}		

				example=TOOLBAR.book[chapter][chapterPage];
				currentExample();
		}
		
			
		function previousExample()
		{
		chapterPage--;
		if(chapterPage == 0){
		chapter--;
		
		if(chapter<1)
		{
			contents();
			chapter++;
			chapterPage++;
			return;
		}
		
		chapterPage=TOOLBAR.book[chapter][0];

}
		example=TOOLBAR.book[chapter][chapterPage];
				currentExample();

		}
		
				
		function startChapter(number)
		{
						chapter = number;
						chapterPage=1;
						example=TOOLBAR.book[chapter][chapterPage];
    				currentExample();
	}
		
		function summary(number)
		{
						if(number) number=number;
						else number=chapter;
						
						url='summary';
						top.HTMLOUTPUT.location.href=url.concat(number,'.html') ;
		}
		
		function contents()
		{
			top.HTMLOUTPUT.location.href= '../../Books/Book$ARGV[0]/book.html';
		}
			
		function callExample(number)
			{
							if(number>0) example=number;
            currentExample(); 
				}
			
			function tut()
		{
			top.location.href='http://www.zvon.org/ZvonHTML/Zvon/zvonTutorials_en.html';
		}
			
				function toc()
		{
			exampleDir = '../Examples/Example';

			top.COMMENT.location.href='../../General/examples.html';
			top.INDEX.location.href='../../General/about.html';
			top.HTMLOUTPUT.location.href='book.html';
			top.HTMLSOURCE.location.href='../../General/keywords.html';
			top.CSS.location.href='../../General/cssIn.html';
		}
			
			</SCRIPT>
			</HEAD>
			<FRAMESET ROWS='50,100,*'>
			<FRAME SRC='toolbar.html' NAME='TOOLBAR'>
			<FRAMESET COLS='25%,*'>
			<FRAME SRC='../../General/about.html' NAME='INDEX'>
				<FRAME SRC='../../General/examples.html' NAME='COMMENT'>
				</FRAMESET>

			<FRAMESET COLS='25%,37%,*'>
				<FRAME SRC='book.html' NAME='HTMLOUTPUT'>				
					<FRAME SRC='../../General/keywords.html' NAME='HTMLSOURCE'>
  				<FRAME SRC='../../General/cssIn.html' NAME='CSS'>
			</FRAMESET>
	</FRAMESET>		
		</HTML>";
	close FRAME;
}#sub createMainFrame

sub createMainToolbar
{
return;
	open OUT, ">../Books/Book$ARGV[0]/mainToolbar.html";
	print OUT "
		<HTML>
		<HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		</HEAD>
		<BODY>
		<IMG lenght='$size' height='$size' src='../../Pictures/keywords.jpg' border='0' onMouseDown='top.keywordIndex()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/authors.jpg' border='0' onMouseDown='top.authorIndex()'>
		<IMG lenght='$size' height='$size' src='../../Pictures/tut.jpg' border='0' onMouseDown='top.tut()'>
				
	</BODY></HTML>
				
	";
	close OUT;
}

sub openDatabases  #same in generateIndexes
{
	my (@creators, $data, $cr,$email);

	open IN, "../Databases/authors.db";
	read IN, $data, 1000000;
	close IN;
	
	@creators = split (/<\/creator/sg,$data);  #>


	foreach $cr (@creators)
	{
		if ($cr=~/<email *> *(.*?) *<\/email *>/s)
		{
			$email = $1;
			$cr=~/<creator .*?zvonID *= *[',"](.*?)[',"]/s;
			$authorsDatabase{$email}{'zvonID'} = $1;
			$cr=~/<name *> *(.*?) *<\/name *>/s;
			$authorsDatabase{$email}{'name'} = $1;
		}
	}#foreach
	
}#openDatabases

sub	createChapterSummary
{
	my($number, $title, $i,$ch);
	
	$number = shift(@_);
  $title = shift(@_);

  open SUMMARY, ">../Books/Book$ARGV[0]/summary$number.html";
	
	print SUMMARY "
		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<BASE target='COMMENT'>
		</HEAD>
		<BODY onLoad='focus()'>
		<H3 class='TITLE'><A href='#' target='_blank'/>$title</A></H3>";			

		$i = 1;
	foreach $ch (@_)
		{
				my($text,$description);
				open IN, "../ExampleSources/example$ch.xml";
				read IN,$text,5000000;
				close IN;
				
				$text =~ /<description\s*>\s*(.*?)\s*<\/description/s;
				$description = $1;
				$description =~ s/<stylesheet.*?\/>/<B>This stylesheet<\/B>/g;
				$description =~ s/<example.*?id\s*=\s*["']\s*\w*?(\d+).*?\/>/<A class='exNumber' HREF='javascript:top.callExample($1)'>Example $1<\/A>/g;
				
				print SUMMARY "<DIV><A class='exNumber' HREF='javascript:top.chapter=$number; top.chapterPage=\"$i\";top.callExample($ch);'>[Example $ch]</A> </DIV><P>$description</P>";

			$i++;
		}
	
	print SUMMARY "</BODY></HTML>";
	close SUMMARY;

}# createChapterSummary

sub createPositionFrame
{


	open OUT,  ">../Books/Book$ARGV[0]/position.html";
 print OUT "
 		<HTML><HEAD>
		<link rel='stylesheet' type='text/css' href='../../CSS/tutorial.css'>
		<SCRIPT LANGUAGE='JavaScript'>
		
</SCRIPT>
		</HEAD>
		<BODY class='ST'>
		<FORM >
		<INPUT type='text' size='22' name='title' readonly>
		<INPUT type='text' size='4' name='page' readonly>
		</FORM>
		</BODY></HTML>
		";
	close OUT;
}